# ng-sapphiredb - Angular client [![Build Status](https://travis-ci.org/morrisjdev/ng-realtime-database.svg?branch=master)](https://travis-ci.org/morrisjdev/ng-realtime-database)

<p align="center">
  <a href="https://sapphire-db.com/">
    <img src="https://sapphire-db.com/assets/banner/SapphireDB%20Banner.png" alt="SapphireDb logo">
  </a>
</p>

SapphireDb is a self-hosted, easy to use realtime database for Asp.Net Core and EF Core.

It creates a generic API you can easily use with different clients to effortlessly create applications with realtime data synchronization.
SapphireDb should serve as a self hosted alternative to firebase realtime database and firestore on top of .Net.

Check out the documentation for more details: [Documentation](https://sapphire-db.com/)

<p align="center">
    <a href="https://www.patreon.com/user?u=27738280"><img src="https://c5.patreon.com/external/logo/become_a_patron_button@2x.png" width="160"></a>
</p>

## Features

- :wrench: Dead simple configuration
- :satellite: Broad technology support
- :computer: Self hosted
- :iphone: Offline support
- :floppy_disk: Easy to use CRUD operations
- :zap: Model validation
- :heavy_check_mark: Database support
- :open_file_folder: Supports joins/includes
- :loop: Complex server evaluated queries
- :electric_plug: Actions
- :key: Authorization included
- :envelope: Messaging
- :globe_with_meridians: Scalable

[Learn more](https://sapphire-db.com/)


## Installation

### Install Package
To use ng-sapphiredb you have to install the package using npm

In your angular app folder execute

```
npm install ng-sapphiredb sapphiredb axios -S
```

### Import SapphireDbModule in your app.module

```
imports: [
    BrowserModule,
    SapphireDbModule,
]
```

## Browser compatibility

| Browser              | Websocket          | SSE                | Polling            |
|----------------------|--------------------|--------------------|--------------------|
| Chrome               | :heavy_check_mark: | :heavy_check_mark: | :heavy_check_mark: |
| Firefox              | :heavy_check_mark: | :x:                | :heavy_check_mark: |
| Opera                | :heavy_check_mark: | :x:                | :heavy_check_mark: |
| Edge                 | :heavy_check_mark: | :x:                | :heavy_check_mark: |
| Internet Explorer 11 | :heavy_check_mark: | :x:                | :heavy_check_mark: |

# Example

[Angular Example](https://github.com/SapphireDb/Example-Angular)

## Documentation

Check out the documentation for more details: [Documentation](https://sapphire-db.com/)

## Implementations/Packages

### Server

[SapphireDb - Server for Asp.Net Core](https://github.com/morrisjdev/SapphireDb)

[SapphireDb.RedisSync](https://github.com/SapphireDb/SapphireDb/tree/master/SapphireDb.RedisSync)

[SapphireDb.HttpSync](https://github.com/SapphireDb/SapphireDb/tree/master/SapphireDb.HttpSync)

### Client

[sapphiredb - JS client (JS, NodeJs, React, Svelte, ...)](https://github.com/SapphireDb/sapphiredb-js/blob/master/projects/sapphiredb/README.md)

[ng-sapphiredb - Angular client](https://github.com/SapphireDb/sapphiredb-js/blob/master/projects/ng-sapphiredb/README.md)

## Author

[Morris Janatzek](http://morrisj.net) ([morrisjdev](https://github.com/morrisjdev))

## Licenses

SapphireDb - [MIT License](https://github.com/SapphireDb/SapphireDb/blob/master/LICENSE)

sapphiredb-js - [MIT License](https://github.com/SapphireDb/sapphiredb-js/blob/master/LICENSE)
