import { __decorate, __param, __metadata } from 'tslib';
import { InjectionToken, Inject, Optional, NgZone, Injectable, NgModule } from '@angular/core';
import { SapphireDb, SapphireStorage, SapphireClassTransformer } from 'sapphiredb';

const SAPPHIRE_DB_OPTIONS = new InjectionToken('sapphire-db.options');
const SAPPHIRE_DB_STARTUP_TOKEN = new InjectionToken('sapphire-db.startup-token');
let SapphireDbService = class SapphireDbService extends SapphireDb {
    constructor(options, storage, classTransformer, ngZone, startupToken) {
        super(options, storage, classTransformer, (executeCode) => {
            this.ngZone.run(executeCode);
        }, startupToken);
        this.ngZone = ngZone;
    }
};
SapphireDbService.ctorParameters = () => [
    { type: undefined, decorators: [{ type: Inject, args: [SAPPHIRE_DB_OPTIONS,] }] },
    { type: SapphireStorage, decorators: [{ type: Optional }] },
    { type: SapphireClassTransformer, decorators: [{ type: Optional }] },
    { type: NgZone },
    { type: String, decorators: [{ type: Optional }, { type: Inject, args: [SAPPHIRE_DB_STARTUP_TOKEN,] }] }
];
SapphireDbService = __decorate([
    Injectable(),
    __param(0, Inject(SAPPHIRE_DB_OPTIONS)),
    __param(1, Optional()),
    __param(2, Optional()),
    __param(4, Optional()), __param(4, Inject(SAPPHIRE_DB_STARTUP_TOKEN)),
    __metadata("design:paramtypes", [Object, SapphireStorage,
        SapphireClassTransformer,
        NgZone, String])
], SapphireDbService);

let SapphireDbModule = class SapphireDbModule {
};
SapphireDbModule = __decorate([
    NgModule({
        imports: [],
        declarations: [],
        providers: [
            SapphireDbService,
            { provide: SAPPHIRE_DB_OPTIONS, useValue: null },
        ]
    })
], SapphireDbModule);

/*
 * Public API Surface of ng-sapphiredb
 */

/**
 * Generated bundle index. Do not edit.
 */

export { SAPPHIRE_DB_OPTIONS, SAPPHIRE_DB_STARTUP_TOKEN, SapphireDbModule, SapphireDbService };
//# sourceMappingURL=ng-sapphiredb.js.map
